//GUID   HID (GUID- 128- ,     = {4D1E55B2-F16F-11CF-88CB-001111000030}
//    "\\?\hid#vid_16c0&pid_05df#6&6c38c&0&0000#{4d1e55b2-f16f-11cf-88cb-001111000030}"
//HidHandle =   HID  ..   
//HidDeviceObject  =     HID ,        
// THIDDAttributes =    ()  HID  (VID, PID, VersionNumber)
// HWND = type LongWord; >> HiAsm WINDOWS.PAS
//========================================================================================================================================================================

unit hiHID;

interface //    (, ,   ),      
      

uses Kol,Share,Windows,Messages,Debug;

const
//       
 CfgMgrModuleName = 'cfgmgr32.dll';
 SetupApiModuleName = 'SetupApi.dll';
 HidModuleName = 'hid.dll';
 OleModuleName = 'ole32.dll';

 //========       SetupDiGetClassDevs  ========================================================
const  //  DIGCF_PRESENT or DIGCF_DEVICEINTERFACE   ,   SetupDiGetClassDevsW    
  DIGCF_DEFAULT = $00000001; // only valid with DIGCF_DEVICEINTERFACE   ,      
  DIGCF_PRESENT = $00000002; //    ,       
  DIGCF_ALLCLASSES = $00000004; //        ,      .    
  DIGCF_PROFILE = $00000008; //    ,      
  DIGCF_DEVICEINTERFACE = $00000010; //   ,    
//=============================================================================================================================  
 SPDRP_FRIENDLYNAME = $0000000C;
  SPDRP_DEVICEDESC = $00000000;
DN_ROOT_ENUMERATED = $00000001; // Was enumerated by ROOT


type
	RETURN_TYPE = DWORD;
	CONFIGRET = RETURN_TYPE;
	//POleStr = PWideChar;
	HDEVINFO = THandle; // THandle = LongWord;  32  =HiAsm WINDOWS.PAS 
	//DI_FUNCTION = UINT;
	//DEVINSTID_A = PAnsiChar;
	//PPNP_VETO_TYPE = ^PNP_VETO_TYPE;
	//PNP_VETO_TYPE = DWORD;
  
//====================================================================================== 
 //        
  ULONG_PTR = ^ ULONG;
  //    SetupDiEnumDeviceInfo
   PSPDevInfoData = ^TSPDevInfoData;
  SP_DEVINFO_DATA = packed record
    cbSize: DWORD;
    ClassGuid: TGUID;
    DevInst: DWORD; // DEVINST handle
    Reserved: ULONG_PTR;
  end;
  TSPDevInfoData = SP_DEVINFO_DATA;
 // DevData: TSPDevInfoData;     var
  //===================================================================================== 
  
 //===================================================================================== 
 //        
 // DeviceInterfaceData: TSPDeviceInterfaceData;
  //     SetupDiEnumDeviceInterfaces
   PSPDeviceInterfaceData = ^TSPDeviceInterfaceData;
  SP_DEVICE_INTERFACE_DATA = packed record
    cbSize: DWORD;
    InterfaceClassGuid: TGUID;
    Flags: DWORD;
    Reserved: ULONG_PTR;
  end;
  TSPDeviceInterfaceData = SP_DEVICE_INTERFACE_DATA;
//DeviceInterfaceData: TSPDeviceInterfaceData;     var
 //======================================================================================  
 
//====================================================================================== 
 //        
//     SetupDiGetDeviceInterfaceDetailA
 const
 ANYSIZE_ARRAY = 1;
  type
 PSPDeviceInterfaceDetailData = ^TSPDeviceInterfaceDetailData;
  SP_DEVICE_INTERFACE_DETAIL_DATA = packed record
    cbSize: DWORD;
    DevicePath: array [0..ANYSIZE_ARRAY-1] of WideChar; //         API, 
	//   ,     , ,     API,       
  end;
  TSPDeviceInterfaceDetailData = SP_DEVICE_INTERFACE_DETAIL_DATA;
 //FunctionClassDeviceData: PSPDeviceInterfaceDetailData;     var
  //======================================================================================  
  
 //======================================================================================   
 //         
 //     HidD_GetAttributes
  PHIDDAttributes = ^THIDDAttributes;
  HIDD_ATTRIBUTES = record
    cbSize:          ULONG; //   (  )
    VendorID:      Word; //  VID
    ProductID:     Word; //  PID
    VersionNumber: Word; //    HID
   end;
  THIDDAttributes = HIDD_ATTRIBUTES; 
//Attributes : THIDDAttributes;    var
//========================================================================================= 

//========================================================================================= 
//===         =================== 
const
  DBT_DEVTYP_OEM       = 0;
  DBT_DEVTYP_DEVNODE	 = 1;
  DBT_DEVTYP_VOLUME    = 2;
  DBT_DEVTYP_PORT	     = 3;
  DBT_DEVTYP_NET	     = 4;
  DBT_DEVTYP_DEVICEINTERFACE = 5;
  DBT_DEVTYP_HANDLE    = 6;
  
  DEVICE_NOTIFY_ALL_INTERFACE_CLASSES =  4;
  GUID_DEVINTERFACE_USB_DEVICE: TGUID = '{A5DCBF10-6530-11D2-901F-00C04FB951ED}';
 //== (    ) ===================================================   
 //         
 //       RegisterDeviceNotification =    WM_DEVICECHANGE
type
PDevBroadcastHdr  = ^DEV_BROADCAST_HDR;
DEV_BROADCAST_HDR = packed record
   dbch_size: DWORD;//                                                                                                         
   dbch_devicetype: DWORD; //  ,      >>DBT_DEVTYP_DEVICEINTERFACE (0x00000005)>>>>>>>                           DEV_BROADCAST_DEVICEINTERFACE
   dbch_reserved: DWORD;  // =                                                     //DBT_DEVTYP_HANDLE (0x00000006)>>>>>>>>>>>>>>>>                DEV_BROADCAST_HANDLE 
end;																								//DBT_DEVTYP_OEM (0x00000000)>>>>>>>>>>>>>>>>>>>OEM-  IHV-    DEV_BROADCAST_OEM//DBT_DEVTYP_PORT (0x00000003)>>>>>>>>>>>>>>>>>>  (  )  DEV_BROADCAST_PORT
                                                                                                    //DBT_DEVTYP_VOLUME (0x00000002)

 //== (   ) ==========================================================   
 //         
 //   WM_DEVICECHANGE =         
PDEV_BROADCAST_DEVICEINTERFACE = ^DEV_BROADCAST_DEVICEINTERFACE;
DEV_BROADCAST_DEVICEINTERFACE = record
    dbcc_size:DWORD;
    dbcc_devicetype:DWORD;
    dbcc_reserved:DWORD;
    dbcc_classguid:TGUID;
    dbcc_name:short;
   end;
   

type
   THIHID = class(TDebug)
   MyHidName:string; //             
 
private   //     ,       
    
	public   //    ,        
    _event_onOut1:THI_Event;       //  1
    _event_onOut2:THI_Event;       //  2
    _event_onReadOut:THI_Event;       //  3 
    _event_onAddTable:THI_Event;       //  4
	_event_onFoundDevice:THI_Event; //    
	_event_onErrOut:THI_Event;       //       WinApi
	_event_onClearTable:THI_Event;       //     
	_data_VID:THI_Event;	//    
	_data_PID:THI_Event;	//
	_data_VIDName:THI_Event;	//
	_data_PIDName:THI_Event;	//
	_data_SerNum:THI_Event;			//     , , 
	_data_ControlByte:THI_Event;	//  
	_data_AddressByte:THI_Event;	//  
	_data_DataByte:THI_Event;	//  
	
//=====        =================================
    function GUIDToString(const GUID: TGUID): string;
    procedure _work_doEnum(var _Data:TData; Index:word); 
    procedure _work_doReadDevice(var _Data:TData; Index:word);
	procedure _work_doWriteDevice(var _Data:TData; Index:word);
	procedure ErrorOut(AddressErr:string; FunName:string);//   WinApi   GetLastError FunName=    AddressErr=  
	function GetDeviceName(HidHandle: HDEVINFO; const DevData: TSPDevInfoData): string; 
end;
//=====    ===================================================================================================================================================
//  HID.dll
{1} procedure HidD_GetHidGuid(var HidGuid: TGUID) stdcall; external HidModuleName name 'HidD_GetHidGuid'; //  GUID   HID 
        function HidD_GetIndexedString(HidDeviceObject: THandle;  Index: Integer; Buffer: PWideChar; BufferLength: Integer): BOOL; stdcall; external HidModuleName name 'HidD_GetIndexedString';
	    function HidD_GetAttributes(HidDeviceObject: THandle;var HidAttrs: THIDDAttributes): BOOL; stdcall; external HidModuleName name 'HidD_GetAttributes';
        function HidD_GetManufacturerString(HidDeviceObject: THandle; Buffer: PWideChar; BufferLength: Integer): BOOL; stdcall; external HidModuleName name 'HidD_GetManufacturerString';
        function HidD_GetProductString(HidDeviceObject: THandle; Buffer: PWideChar; BufferLength: Integer): BOOL; stdcall; external HidModuleName name 'HidD_GetProductString';
        function HidD_GetSerialNumberString(HidDeviceObject: THandle; Buffer: PWideChar; BufferLength: Integer): BOOL; stdcall; external HidModuleName name 'HidD_GetSerialNumberString';//       ()
	    function HidD_GetNumInputBuffers(HidDeviceObject: THandle;var NumBufs: Integer): BOOL; stdcall; external HidModuleName name 'HidD_GetNumInputBuffers';
		function HidD_SetFeature(HidDeviceObject: THandle;var Report; Size: Integer): BOOL; stdcall; external HidModuleName name 'HidD_SetFeature';
		function HidD_GetFeature(HidDeviceObject: THandle;var Report; Size: Integer): BOOL; stdcall; external HidModuleName name 'HidD_GetFeature';
		
//   Ole32.dll
        function StringFromGUID2(const GUID: TGUID; psz: PWideChar; cbMax: Integer): Integer; stdcall; external OleModuleName name 'StringFromGUID2'; //  GUID     WinApi
//   SetupApi.dll
{2}   function SetupDiGetClassDevsW(HidGuid: PGUID; const Enumerator: PAnsiChar; hwndParent: HWND; Flags: DWORD): HDEVINFO; stdcall; external SetupApiModuleName name 'SetupDiGetClassDevsW';//    HID 
{3}   function SetupDiEnumDeviceInfo(DeviceInfoSet: HDEVINFO; MemberIndex: DWORD; var DeviceInfoData: TSPDevInfoData): BOOL; stdcall; external SetupApiModuleName name 'SetupDiEnumDeviceInfo';//    ,  = "HID- "
{4}   function SetupDiEnumDeviceInterfaces(DeviceInfoSet: HDEVINFO;  DeviceInfoData: PSPDevInfoData; const InterfaceClassGuid: TGUID;  MemberIndex: DWORD; var DeviceInterfaceData: TSPDeviceInterfaceData): BOOL; stdcall; external SetupApiModuleName name 'SetupDiEnumDeviceInterfaces';//        (      )
{5}   function SetupDiGetDeviceInterfaceDetailA(DeviceInfoSet: HDEVINFO;  DeviceInterfaceData: PSPDeviceInterfaceData;  DeviceInterfaceDetailData: PSPDeviceInterfaceDetailData;  DeviceInterfaceDetailDataSize: DWORD; var RequiredSize: DWORD;  Device: PSPDevInfoData): BOOL; stdcall; external SetupApiModuleName name 'SetupDiGetDeviceInterfaceDetailA'; //      (    HidDeviceObject)
       function SetupDiGetDeviceRegistryPropertyA(DeviceInfoSet: HDEVINFO; const DeviceInfoData: TSPDevInfoData; Property_: DWORD; var PropertyRegDataType: DWORD; PropertyBuffer: PBYTE; PropertyBufferSize: DWORD; var RequiredSize: DWORD): BOOL; stdcall; external SetupApiModuleName name 'SetupDiGetDeviceRegistryPropertyA';
       function SetupDiDestroyDeviceInfoList(DeviceInfoSet: HDEVINFO): BOOL; stdcall; external SetupApiModuleName name 'SetupDiDestroyDeviceInfoList';
//   cfgmgr32.dll
       function CM_Enumerate_Classes(ulClassIndex: ULONG; var ClassGuid: TGUID; ulFlags: ULONG): CONFIGRET; stdcall; external CfgMgrModuleName name 'CM_Enumerate_Classes'; //  GUID    (    
//============================================================================================================================================================================


implementation 
 //          ,    ,    ,   ,        . 


procedure THIHID._work_doEnum;                  
const
	StrDelim =';'; //     
	DBT_DEVICEARRIVAL           = $8000; // system detected a new device

	var
    //_DN,_PN:ULONG;//       HidName : string;                                             
	HidDeviceObject : THandle;//  
	HidGuid : TGUID; ///    ( ) HiAsm WINDOWS.PAS  TGUID = packed record
	HidHandle : HDEVINFO;//  (Handle-) HID  >>          
	PIDName, VIDName, Attrib, SN, DevNum, DeviceName, HidName: string; //        
	DevIndex : Integer; //     HidHandle
	DeviceInterfaceData: TSPDeviceInterfaceData;//    SetupDiEnumDeviceInterfaces
	FunctionClassDeviceData: PSPDeviceInterfaceDetailData;//     SetupDiGetDeviceInterfaceDetail
	Attributes : THIDDAttributes; //   VID PID
	DeviceInfoData : SP_DEVINFO_DATA;// 
{ ---------      GUID HID  -------} 
	ArrHidGuid: array[0..39] of WideChar;//      
	RetSymbol: integer; // -   ( 39)
	SGUID: string; //    
{================================================================}
{ ---------    -------} 
	dbi:DEV_BROADCAST_DEVICEINTERFACE; //DBT_DEVTYP_DEVICEINTERFACE (0x00000005)>>>>>>> 
	Size: Integer;
{================================================================}
   Buffer : array[0..253] of WideChar;
   Success: BOOL;
  DevData: TSPDevInfoData;
  BytesReturned: DWORD;
  CompCount:integer;
	CompStr:string;
begin 

 
    _hi_OnEvent(_event_onClearTable);//    
 //=====  GUID HID      =========================================================================================================================  
	HidD_GetHidGuid(HidGuid);  //  GUID   HID (GUID- 128- ,  = {4D1E55B2-F16F-11CF-88CB-001111000030}       
	RetSymbol:=StringFromGUID2(HidGuid,ArrHidGuid,39);//    Win Api (ole32.dll) (39- GUID     )        
	{    GUID (   "//"}
	//SGUID:=GUIDToString(HidGuid); //     HiAsm  hiDeviceInfo.pas
	SGUID:=ArrHidGuid;//       GUID
	_hi_OnEvent(_event_onOut1,SGUID+ ' -  = ' + Int2Str(integer (RetSymbol)));//  GUID    
//==================================================================================================================================	
//    (Handle)    (   HID	
	HidHandle := SetupDiGetClassDevsW(@HidGuid, nil, 0, DIGCF_PRESENT or DIGCF_DEVICEINTERFACE );  //    GUID HID    ( . descriptor )  HID   
	If HidHandle = INVALID_HANDLE_VALUE then ErrorOut('begin Enum','SetupDiGetClassDevsW'); //      
//================================================================================================================================================================================= 	
//      
//Try	
	DevIndex := 0;  //   
	Repeat         //       HID-.      VID PID    .
//================================================================================================================================================================================= 			
//        "HID- "
	DevData.cbSize := SizeOf(DevData);//   SizeOf(X) : integer; >>   ,    X  
	Success :=  SetupDiEnumDeviceInfo(HidHandle, DevIndex, DevData) ; //       "HID- "
	If not Success then begin ErrorOut(Int2Str(integer (DevIndex)),'SetupDiEnumDeviceInfo') end //      
						else begin DeviceName:=GetDeviceName(HidHandle, DevData);
//================================================================================================================================================================================= 		
//     ,  DeviceInterfaceData  SetupDiGetDeviceInterfaceDetailA
	DeviceInterfaceData.cbSize := SizeOf(TSPDeviceInterfaceData);//   SizeOf(X) : integer; >>   ,    X  
	if not SetupDiEnumDeviceInterfaces(HidHandle , nil, HidGuid, DevIndex, DeviceInterfaceData) then ErrorOut(Int2Str(integer (DevIndex)),'SetupDiEnumDeviceInterfaces') ;//             HidHandle,   DeviceInterfaceData
//================================================================================================================================================================================= 		
//       DeviceInterfaceData,      ,    ,   ,   	
	DevData.cbSize := SizeOf(DevData);// =28
	BytesReturned  := 0;
    if not SetupDiGetDeviceInterfaceDetailA(HidHandle , @DeviceInterfaceData, nil, 0, BytesReturned, @DevData) then ErrorOut(Int2Str(integer (DevIndex)),'1-SetupDiGetDeviceInterfaceDetailA');//   false   ,      
    //ShowMessage('BytesReturned= '+Int2Str(integer (BytesReturned)));
//=================================================================================================================================================================================     
//     "\\?\hid#vid_16c0&pid_05df#6&5ba751f&0&0000#{4d1e55b2-f16f-11cf-88cb-001111000030}"    
	FunctionClassDeviceData := AllocMem(BytesReturned);// AllocMem (Size: Cardinal): Pointer;>>    Size     .    ()
    FunctionClassDeviceData.cbSize := 5; //  5 ? 4  6  
	If SetupDiGetDeviceInterfaceDetailA(HidHandle , @DeviceInterfaceData, FunctionClassDeviceData, BytesReturned, BytesReturned, @DevData) then HidName := PChar(@FunctionClassDeviceData.DevicePath)//;//      .DevicePath        CreateFile()!!!!!
	else ErrorOut(Int2Str(integer (DevIndex)),'2-SetupDiGetDeviceInterfaceDetailA'); //      
//===================================================================================================================================================================================
//  ()  AVR 	
	HidDeviceObject:= CreateFileA(PChar(@HidName[1]), 0,FILE_SHARE_READ or FILE_SHARE_WRITE, 0, OPEN_EXISTING , 0, 0);//         ,      !
	If HidDeviceObject = INVALID_HANDLE_VALUE then ErrorOut(Int2Str(integer (DevIndex)),'CreateFileA'); //      
//===================================================================================================================================================================================
//   
	Attributes.cbSize := SizeOf(THIDDAttributes);//    THIDDAttributes
	If HidD_GetAttributes(HidDeviceObject, Attributes) then Attrib:= Format('%d;%d',[Attributes.VendorID, Attributes.ProductID{, Attributes.VersionNumber}])//    Attributes,   
	else ErrorOut(Int2Str(integer (DevIndex)),'HidD_GetAttributes'); //      
//===================================================================================================================================================================================
//  VID  PID, -    CompCount
	CompCount:=0;
	If Attributes.VendorID = ToIntegerEvent(_data_VID) then Inc(CompCount);
	If Attributes.ProductID = ToIntegerEvent(_data_PID) then Inc(CompCount);
//===================================================================================================================================================================================
//   
//	FillChar(Buffer, SizeOf(Buffer), #0);//   
//	If HidD_GetNumInputBuffers(HidDeviceObject, NumInputBuffers) then s4:= (Format('  =%d',[NumInputBuffers])); 
//===================================================================================================================================================================================
//    ( )
	FillChar(Buffer, SizeOf(Buffer), #0); // FillChar    Buffer       #0, SizeOf(Buffer) //   S,   1 
	If HidD_GetManufacturerString(HidDeviceObject, Buffer, SizeOf(Buffer)) then VIDName:= Format('%S',[Buffer])//;	
	else ErrorOut(Int2Str(integer (DevIndex)),'HidD_GetManufacturerString'); //      
//===================================================================================================================================================================================
//  VID Name, -    CompCount
	If VIDName = ToStringEvent(_data_VIDName) then Inc(CompCount);
//===================================================================================================================================================================================
//    ( )
	FillChar(Buffer, SizeOf(Buffer), #0);//  
	If HidD_GetProductString(HidDeviceObject, Buffer, SizeOf(Buffer)) then PIDName:=Format('%S',[Buffer])//;
	else ErrorOut(Int2Str(integer (DevIndex)),'HidD_GetProductString'); //      
//===================================================================================================================================================================================
//  PID Name, -    CompCount	
	If PIDName = ToStringEvent(_data_PIDName) then Inc(CompCount);
//====================================================================================================================================================================================
//   
	FillChar(Buffer, SizeOf(Buffer), #0);//   
	If HidD_GetSerialNumberString(HidDeviceObject, Buffer, SizeOf(Buffer)) then SN:=Format('%S',[Buffer])//;
	else ErrorOut(Int2Str(integer (DevIndex)),'HidD_GetSerialNumberString'); //      
//===================================================================================================================================================================================
//    , -    CompCount	
	If SN = ToStringEvent(_data_SerNum) then Inc(CompCount);
//===================================================================================================================================================================================
//     CompCount ( - 	
	
	If CompCount > 3 then begin MyHidName := HidName; _hi_OnEvent(_event_onFoundDevice,MyHidName); end; //    3   
							
//====================================================================================================================================================================================
//   
	DevNum:=Int2Str(integer (DevIndex));//   ()    	
	_hi_OnEvent(_event_onAddTable,DevNum + StrDelim + DeviceName + StrDelim + Attrib +StrDelim + VIDName +StrDelim + PIDName + StrDelim + SN +  StrDelim + HidName);//         
//====================================================================================================================================================================================
// 
PIDName:='';
VIDName:='';
Attrib:='';
SN:='';
DevNum:='';
DeviceName:='';
HidName:='';
//   HidDeviceObject     CreateFileA
	
	if not CloseHandle(HidDeviceObject) then ErrorOut(Int2Str(integer (DevIndex)),'CloseHandle');  //       
	FreeMem(FunctionClassDeviceData); // ,  
								
							end; //     SetupDiEnumDeviceInterfaces	
//====================================================================================================================================================================================
	Inc(DevIndex);//   
	Until not Success; //    Success = 0 (  SetupDiEnumDeviceInterfaces   )
//Finally	
//====================================================================================================================================================================================	
//   
	
	if not SetupDiDestroyDeviceInfoList(HidHandle) then ErrorOut('Finally','SetupDiDestroyDeviceInfoList');
//end; 
end;
//================================================================================================
//--  GetLastError
//================================================================================================ 
 //    WinApi   GetLastError
procedure THIHID.ErrorOut(AddressErr:string; FunName:string);
begin
_hi_OnEvent(_event_onErrOut,AddressErr+';'+FunName+';'+Int2Str(GetLastError)); 
end; 
//================================================================================================
//-- 
//================================================================================================ 
procedure THIHID._work_doReadDevice; 
var
	BufferAVR : array[0..3] of Byte;//    3  (+1=ID)
	DeviceAVR:THandle;
begin
	FillChar(BufferAVR, SizeOf(BufferAVR), #0);
	DeviceAVR:= CreateFileA(PChar(@MyHidName[1]), 0,FILE_SHARE_READ or FILE_SHARE_WRITE, 0, OPEN_EXISTING , 0, 0);//         ,      !
	If DeviceAVR = INVALID_HANDLE_VALUE then ErrorOut('doReadDevice','CreateFileA'); //      
	If not HidD_GetFeature(DeviceAVR,BufferAVR,SizeOf(BufferAVR)) then ErrorOut('doReadDevice','HidD_GetFeature');  
	if not CloseHandle(DeviceAVR) then ErrorOut('doReadDevice','CloseHandle');  //    CreateFile
	_hi_OnEvent(_event_onReadOut,Int2Str(BufferAVR[1])+';'+Int2Str(BufferAVR[2])+';'+Int2Str(BufferAVR[3]));
end;  
//================================================================================================
//-- 
//================================================================================================ 
procedure THIHID._work_doWriteDevice;
var
	BufferAVR : array[0..3] of Byte;
	DeviceAVR:THandle;
begin
	FillChar(BufferAVR, SizeOf(BufferAVR), #0);
	BufferAVR[0]:=0;//   (Report ID),     = 0 (  ),   +1
	BufferAVR[1]:=ToIntegerEvent(_data_DataByte);// 
	BufferAVR[2]:=ToIntegerEvent(_data_ControlByte);// 
	BufferAVR[3]:=ToIntegerEvent(_data_AddressByte);// 
	DeviceAVR:= CreateFileA(PChar(@MyHidName[1]), 0,FILE_SHARE_READ or FILE_SHARE_WRITE, 0, OPEN_EXISTING , 0, 0);//         ,      !
	If DeviceAVR = INVALID_HANDLE_VALUE then ErrorOut('doWriteDevice','CreateFileA'); //      
	If not HidD_SetFeature(DeviceAVR,BufferAVR,SizeOf(BufferAVR)) then ErrorOut('doWriteDevice','HidD_SetFeature');  
	if not CloseHandle(DeviceAVR) then ErrorOut('doWriteDevice','CloseHandle');  //    CreateFile
end;


//=================================================================
function THIHID.GUIDToString(const GUID: TGUID): string;//   HiAsm hiDeviceInfo.pas
begin
  Result := '{' + Int2Hex(GUID.D1, 8)    + '-' + Int2Hex(GUID.D2, 4)    + '-' +
                  Int2Hex(GUID.D3, 4)    + '-' + Int2Hex(GUID.D4[0], 2) +
                  Int2Hex(GUID.D4[1], 2) + '-' + Int2Hex(GUID.D4[2], 2) +
                  Int2Hex(GUID.D4[3], 2)       + Int2Hex(GUID.D4[4], 2) +
                  Int2Hex(GUID.D4[5], 2)       + Int2Hex(GUID.D4[6], 2) +
                  Int2Hex(GUID.D4[7], 2)       + '}';
end;
//====================================================================

//          SP_DEVINFO_DATA.
//function GetDeviceName(HidHandle: HDEVINFO; const DevData: TSPDevInfoData): string; 
function THIHID.GetDeviceName;
var
  BytesReturned: DWORD;
  RegDataType: DWORD;
  Buffer: array [0..256] of AnsiChar;
begin
  BytesReturned := 0;
  RegDataType := 0;
  Buffer[0] := #0;
  SetupDiGetDeviceRegistryPropertyA(HidHandle, DevData, SPDRP_FRIENDLYNAME,
RegDataType, PByte(@Buffer[0]), SizeOf(Buffer), BytesReturned);
  Result := Buffer;
  if Result<>'' then exit;
  BytesReturned := 0;
  RegDataType := 0;
  Buffer[0] := #0;
  SetupDiGetDeviceRegistryPropertyA(HidHandle, DevData, SPDRP_DEVICEDESC,
RegDataType, PByte(@Buffer[0]), SizeOf(Buffer), BytesReturned);
  Result:=Buffer;
end;

end.